import { useState } from "react"

const log = console.log
let cache: Array<any> = []
const clear = () => cache = []

export default <T>(factory: () => T): T => {
    return useState(() => {
        if (log === console.log) {
            queueMicrotask(clear)
            const result = factory()
            cache.push(result)
            return result
        }
        return cache.shift()
    })[0]
}